import ./macros/give_generic_item.mcm
import ./macros/give_generic_block.mcm
import ./macros/recipe.mcm
import ./macros/tnt_explode.mcm



function load{
    scoreboard objectives add wasd_data_packs dummy
    scoreboard players set wasd_picks wasd_data_packs 1
    scoreboard players set camp_datapack wasd_data_packs 1
    scoreboard objectives add wasd.dia_pick minecraft.used:minecraft.diamond_pickaxe
    scoreboard objectives add wasd.golden_pick minecraft.used:minecraft.golden_pickaxe
    scoreboard objectives add wasd.iron_pick minecraft.used:minecraft.iron_pickaxe
    scoreboard objectives add wasd.nthr_pick minecraft.used:minecraft.netherite_pickaxe
    scoreboard objectives add wasd.wood_pick minecraft.used:minecraft.wooden_pickaxe
    scoreboard objectives add wasd.momentum dummy
    scoreboard objectives add w.pick_setting dummy
    scoreboard objectives add wasd.pick_type dummy
    scoreboard objectives add w.pick_sneaking minecraft.custom:minecraft.sneak_time

    
    #enable crafter
    scoreboard objectives add wasd.lib_setting dummy
    scoreboard players set wasd.crafter wasd.lib_setting 1
    schedule function wasd.pick:outdated_lib 1t
    schedule function wasd.pick:missing_diamonds 1t
    function wasd.pick:config
}

function config{
    \#Enable/Disable recipes. 1 = Enabled/True. 0= Disabled/False.

    \#Enable/Disable all pack recipes.
    scoreboard players set recipes w.pick_setting 1

    \#Enable/Disable Individual Recipes
    scoreboard players set miners w.pick_setting 1
    scoreboard players set tunneler_dream w.pick_setting 1
    scoreboard players set molten w.pick_setting 1
    scoreboard players set diamond_miner w.pick_setting 1
    scoreboard players set diamond_tunneler_dream w.pick_setting 1
    scoreboard players set xp w.pick_setting 1
    scoreboard players set rainbow w.pick_setting 1
    scoreboard players set momentum w.pick_setting 1
    scoreboard players set firework w.pick_setting 1
    scoreboard players set pillow w.pick_setting 1
    scoreboard players set tnt w.pick_setting 1
    scoreboard players set magnetic w.pick_setting 1
    scoreboard players set giant_diamond w.pick_setting 1
    scoreboard players set control w.pick_setting 1
    scoreboard players set torch w.pick_setting 1
    scoreboard players set diamond_torch w.pick_setting 1
    scoreboard players set efficient w.pick_setting 1
    scoreboard players set wither w.pick_setting 1
    scoreboard players set lucky w.pick_setting 1
    scoreboard players set dragon w.pick_setting 1
    scoreboard players set ice w.pick_setting 1
    scoreboard players set snow w.pick_setting 1
    scoreboard players set log w.pick_setting 1



    scoreboard players set cow w.pick_setting 1
    scoreboard players set bookshelf w.pick_setting 1
    scoreboard players set cake w.pick_setting 1
    scoreboard players set creeper w.pick_setting 1
    scoreboard players set fortunate w.pick_setting 1


}

function outdated_lib{
    execute unless score version wasd.lib_setting matches 66.. run block{
        tellraw @a [""]
        tellraw @a {"text":"The required Library pack is missing or out of date.","color":"dark_red"}
        tellraw @a [""]
        tellraw @a {"text":"Install the latest Library version. [Click]","color":"dark_green","clickEvent":{"action":"open_url","value":"http://wasdbuildteam.website/data-packs/wasd-libraries/"}}
        tellraw @a [""]
        tellraw @a [{"text":"Packs by ","color":"gray"},{"text":"The WASD Build Team","color":"dark_red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/channel/UCzulxVWHmcJHg7Wkux_PkeQ"},"hoverEvent":{"action":"show_text","value":"YouTube"}}]
        tellraw @a [{"text":"[Datapacks] ","color":"dark_green","clickEvent":{"action":"open_url","value":"http://wasdbuildteam.website/Data-Packs/"},"hoverEvent":{"action":"show_text","value":"WASD Website"}},{"text":"[Patreon] ","color":"gold","clickEvent":{"action":"open_url","value":"https://www.patreon.com/WASD_Build_Team"},"hoverEvent":{"action":"show_text","value":"Patreon"}},{"text":"[Discord]","color":"dark_aqua","clickEvent":{"action":"open_url","value":"https://discordapp.com/invite/yqk4VfA"},"hoverEvent":{"action":"show_text","value":"Discord"}}]
    }
}

function missing_diamonds{
    execute unless score wasd_diamonds wasd_data_packs matches 1.. run block{
        tellraw @a [""]
        tellraw @a {"text":"This pack relies on Moar Diamonds for the recipes.","color":"dark_red"}
        tellraw @a [""]
        tellraw @a {"text":"Install Moar Diamonds to craft the axes. [Click]","color":"dark_green","clickEvent":{"action":"open_url","value":"http://wasdbuildteam.website/data-packs/moar-diamonds/"}}
        tellraw @a [""]
        tellraw @a [{"text":"Packs by ","color":"gray"},{"text":"The WASD Build Team","color":"dark_red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/channel/UCzulxVWHmcJHg7Wkux_PkeQ"},"hoverEvent":{"action":"show_text","value":"YouTube"}}]
        tellraw @a [{"text":"[Datapacks] ","color":"dark_green","clickEvent":{"action":"open_url","value":"http://wasdbuildteam.website/Data-Packs/"},"hoverEvent":{"action":"show_text","value":"WASD Website"}},{"text":"[Patreon] ","color":"gold","clickEvent":{"action":"open_url","value":"https://www.patreon.com/WASD_Build_Team"},"hoverEvent":{"action":"show_text","value":"Patreon"}},{"text":"[Discord]","color":"dark_aqua","clickEvent":{"action":"open_url","value":"https://discordapp.com/invite/yqk4VfA"},"hoverEvent":{"action":"show_text","value":"Discord"}}]
    }
}

function tick{
    execute as @a at @s run function wasd.pick:as_players
    #crafting
    execute if score recipes w.pick_setting matches 1 as @e[tag=wasd.custom_crafter,tag=wasd.crafter.has_items,tag=wasd.crafter_change] at @s run function wasd.pick:recipes
}


function as_players{

    execute as @s[scores={wasd.wood_pick=1..}] run function wasd.pick:determine_wood
    execute as @s[scores={wasd.dia_pick=1..}] run function wasd.pick:determine_dia
    execute as @s[scores={wasd.iron_pick=1..}] run function wasd.pick:determine_iron
    execute as @s[scores={wasd.golden_pick=1..}] run function wasd.pick:determine_golden
    execute as @s[scores={wasd.nthr_pick=1..}] run function wasd.pick:determine_netherite
    
    execute as @s[tag=wasd.hotbar_slot_changed] store result score @s wasd.pick_type run data get entity @s SelectedItem.tag."wasd.custom_pick"

    execute as @s[scores={wasd.pick_type=1..}] run function wasd.pick:holding_pickaxe



    scoreboard players reset @s[scores={w.pick_sneaking=1..}] w.pick_sneaking

}

function holding_pickaxe{
    execute as @s[scores={wasd.pick_type=8}] run function wasd.pick:code/momentum_math
    execute as @s[scores={wasd.pick_type=10}] run effect give @s minecraft:mining_fatigue 1 0 true
    execute as @s[scores={wasd.pick_type=17}] run function wasd.pick:code/control
    execute as @s[scores={wasd.pick_type=23}] run effect give @s minecraft:mining_fatigue 1 0 true


}

function determine_wood{
    execute as @s[scores={wasd.pick_type=23}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/log
    execute as @s[scores={wasd.pick_type=24}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/snow
    scoreboard players reset @s wasd.wood_pick
}

function determine_iron{
    execute as @s[scores={wasd.pick_type=1}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/strip
    execute as @s[scores={wasd.pick_type=2}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/tunnel
    execute as @s[scores={wasd.pick_type=9}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/firework
    execute as @s[scores={wasd.pick_type=12}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/magnetic
    execute as @s[scores={wasd.pick_type=18}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/torch
    execute as @s[scores={wasd.pick_type=25}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:patron/code/bookshelf
    execute as @s[scores={wasd.pick_type=26}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:patron/code/cake
    execute as @s[scores={wasd.pick_type=27}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:patron/code/creeper
    scoreboard players reset @s wasd.iron_pick
}

function determine_golden{
    execute as @s[scores={wasd.pick_type=11}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/tnt
    execute as @s[scores={wasd.pick_type=22}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:patron/code/cow
    scoreboard players reset @s wasd.golden_pick
}

function determine_dia{
    execute as @s[scores={wasd.pick_type=3}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/smelter
    execute as @s[scores={wasd.pick_type=4}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/diamond_strip
    execute as @s[scores={wasd.pick_type=5}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/diamond_tunnel
    execute as @s[scores={wasd.pick_type=6}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/xp
    execute as @s[scores={wasd.pick_type=7}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s align xyz positioned ~0.5 ~0.5 ~0.5 run function wasd.pick:code/rainbow
    execute as @s[scores={wasd.pick_type=8}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/momentum
    execute as @s[scores={wasd.pick_type=15}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/obsidian
    execute as @s[scores={wasd.pick_type=16}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/giant_diamond
    execute as @s[scores={wasd.pick_type=19}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/torch
    execute as @s[scores={wasd.pick_type=28}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/ice
    execute as @s[scores={wasd.pick_type=29}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/lucky
    scoreboard players reset @s wasd.dia_pick
}

function determine_netherite{
    execute as @s[scores={wasd.pick_type=21}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/wither
    execute as @s[scores={wasd.pick_type=30}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:code/dragon
    execute as @s[scores={wasd.pick_type=31}] positioned ^ ^ ^3 as @e[type=item,sort=nearest,limit=1,nbt={OnGround:0b,Age:0s}] at @s run function wasd.pick:patron/code/fortunate
    scoreboard players reset @s wasd.nthr_pick
}

function give_items{
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Miner\'s Pickaxe","italic":false}'},CustomModelData:6370008,wasd.custom_pick:1b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Tunnelers Dream","italic":false}'},CustomModelData:6370009,wasd.custom_pick:2b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Molten Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:3b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Diamond Miner\'s Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:4b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Diamond Tunnelers Dream","italic":false}'},CustomModelData:6370004,wasd.custom_pick:5b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"XP Pickaxe","italic":false}'},CustomModelData:6370005,wasd.custom_pick:6b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'[{"text":"R","color":"red","italic":false},{"text":"a","color":"gold"},{"text":"i","color":"yellow"},{"text":"n","color":"dark_green"},{"text":"b","color":"dark_aqua"},{"text":"o","color":"dark_blue"},{"text":"w","color":"dark_purple"},{"text":" Pickaxe","italic":false}]'},CustomModelData:6370006,wasd.custom_pick:7b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Momentum Pickaxe","italic":false}'},CustomModelData:6370007,wasd.custom_pick:8b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:efficiency",lvl:20s}]} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Firework Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:9b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Pillow Pickaxe","italic":false}'},CustomModelData:6370004,wasd.custom_pick:10b,wasd_pickaxe:1b,RepairCost:9001,Enchantments:[{id:"minecraft:silk_touch",lvl:1s}]} 1
    give @p minecraft:golden_pickaxe{display:{Name:'{"text":"TNT Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:11b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Magnetic Pickaxe","italic":false}'},CustomModelData:6370005,wasd.custom_pick:12b,wasd_pickaxe:1b} 1
    #give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Redstone Pickaxe","italic":false}'},CustomModelData:6370006,wasd.custom_pick:13b,wasd_pickaxe:1b} 1
    #give @p minecraft:iron_pickaxe{display:{Name:'{"text":"End Crystal Pickaxe","italic":false}'},CustomModelData:6370007,wasd.custom_pick:14b,wasd_pickaxe:1b} 1
    #give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Obsidian Pickaxe","italic":false}'},CustomModelData:6370008,wasd.custom_pick:15b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Giant Diamond Pickaxe","italic":false}'},CustomModelData:6370009,wasd.custom_pick:16b,wasd_pickaxe:1b} 1
    give @p minecraft:netherite_pickaxe{display:{Name:'{"text":"Control Pickaxe","italic":false}'},CustomModelData:6371002,wasd.custom_pick:17b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Torch Pickaxe","italic":false}'},CustomModelData:6370010,wasd.custom_pick:18b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Diamond Torch Pickaxe","italic":false}'},CustomModelData:6370010,wasd.custom_pick:19b,wasd_pickaxe:1b} 1
    give @p minecraft:netherite_pickaxe{display:{Name:'{"text":"Efficient Pickaxe","italic":false}'},CustomModelData:6371004,wasd.custom_pick:20b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:efficiency",lvl:8s}]} 1
    give @p minecraft:netherite_pickaxe{display:{Name:'{"text":"Wither Pickaxe","italic":false}'},CustomModelData:6371005,wasd.custom_pick:21b,wasd_pickaxe:1b} 1
    give @p minecraft:wooden_pickaxe{display:{Name:'{"text":"Log Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:23b,wasd_pickaxe:1b} 1
    give @p minecraft:wooden_pickaxe{display:{Name:'{"text":"Snow Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:24b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Ice Pickaxe","italic":false}'},CustomModelData:6370011,wasd.custom_pick:28b,wasd_pickaxe:1b} 1
    give @p minecraft:diamond_pickaxe{display:{Name:'{"text":"Lucky Pickaxe","italic":false}'},CustomModelData:6370012,wasd.custom_pick:29b,wasd_pickaxe:1b} 1
    give @p minecraft:netherite_pickaxe{display:{Name:'{"text":"Dragon Pickaxe","italic":false}'},CustomModelData:6371006,wasd.custom_pick:30b,wasd_pickaxe:1b} 1

}

function give_dev{


    #give @p minecraft:warped_fungus_on_a_stick{display:{Name:'{"text":"Witch Pickaxe","italic":false}'},CustomModelData:6370201,wasd.custom_pick:32b,wasd_pickaxe:1b} 1

}

function give_item_box{
    setblock ~ ~ ~ minecraft:light_blue_shulker_box[facing=up]{Items:[{Count:1b,Slot:0b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370008,Damage:0,display:{Name:'{"text":"Miner\'s Pickaxe","italic":false}'},wasd.custom_pick:1b,wasd_pickaxe:1b}},{Count:1b,Slot:1b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370009,Damage:0,display:{Name:'{"text":"Tunnelers Dream","italic":false}'},wasd.custom_pick:2b,wasd_pickaxe:1b}},{Count:1b,Slot:2b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370002,Damage:0,display:{Name:'{"text":"Molten Pickaxe","italic":false}'},wasd.custom_pick:3b,wasd_pickaxe:1b}},{Count:1b,Slot:3b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370003,Damage:0,display:{Name:'{"text":"Diamond Miner\'s Pickaxe","italic":false}'},wasd.custom_pick:4b,wasd_pickaxe:1b}},{Count:1b,Slot:4b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370004,Damage:0,display:{Name:'{"text":"Diamond Tunnelers Dream","italic":false}'},wasd.custom_pick:5b,wasd_pickaxe:1b}},{Count:1b,Slot:5b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370005,Damage:0,display:{Name:'{"text":"XP Pickaxe","italic":false}'},wasd.custom_pick:6b}},{Count:1b,Slot:6b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370006,Damage:0,display:{Name:'[{"text":"R","color":"red","italic":false},{"text":"a","color":"gold"},{"text":"i","color":"yellow"},{"text":"n","color":"dark_green"},{"text":"b","color":"dark_aqua"},{"text":"o","color":"dark_blue"},{"text":"w","color":"dark_purple"},{"text":" Pickaxe","italic":false}]'},wasd.custom_pick:7b}},{Count:1b,Slot:7b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370007,Damage:0,Enchantments:[{id:"minecraft:efficiency",lvl:20s}],display:{Name:'{"text":"Momentum Pickaxe","italic":false}'},wasd.custom_pick:8b,wasd_pickaxe:1b}},{Count:1b,Slot:8b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370003,Damage:0,display:{Name:'{"text":"Firework Pickaxe","italic":false}'},wasd.custom_pick:9b,wasd_pickaxe:1b}},{Count:1b,Slot:9b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370004,Damage:0,Enchantments:[{id:"minecraft:silk_touch",lvl:1s}],RepairCost:9001,display:{Name:'{"text":"Pillow Pickaxe","italic":false}'},wasd.custom_pick:10b,wasd_pickaxe:1b}},{Count:1b,Slot:10b,id:"minecraft:golden_pickaxe",tag:{CustomModelData:6370002,Damage:0,display:{Name:'{"text":"TNT Pickaxe","italic":false}'},wasd.custom_pick:11b,wasd_pickaxe:1b}},{Count:1b,Slot:11b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370005,Damage:0,display:{Name:'{"text":"Magnetic Pickaxe","italic":false}'},wasd.custom_pick:12b,wasd_pickaxe:1b}},{Count:1b,Slot:12b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370009,Damage:0,display:{Name:'{"text":"Giant Diamond Pickaxe","italic":false}'},wasd.custom_pick:16b,wasd_pickaxe:1b}},{Count:1b,Slot:13b,id:"minecraft:netherite_pickaxe",tag:{CustomModelData:6371002,Damage:0,display:{Name:'{"text":"Control Pickaxe","italic":false}'},wasd.custom_pick:17b,wasd_pickaxe:1b}},{Count:1b,Slot:14b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370010,Damage:0,display:{Name:'{"text":"Torch Pickaxe","italic":false}'},wasd.custom_pick:18b,wasd_pickaxe:1b}},{Count:1b,Slot:15b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370010,Damage:0,display:{Name:'{"text":"Diamond Torch Pickaxe","italic":false}'},wasd.custom_pick:19b,wasd_pickaxe:1b}},{Count:1b,Slot:16b,id:"minecraft:netherite_pickaxe",tag:{CustomModelData:6371004,Damage:0,Enchantments:[{id:"minecraft:efficiency",lvl:8s}],display:{Name:'{"text":"Efficient Pickaxe","italic":false}'},wasd.custom_pick:20b,wasd_pickaxe:1b}},{Count:1b,Slot:17b,id:"minecraft:netherite_pickaxe",tag:{CustomModelData:6371005,Damage:0,display:{Name:'{"text":"Wither Pickaxe","italic":false}'},wasd.custom_pick:21b,wasd_pickaxe:1b}},{Count:1b,Slot:18b,id:"minecraft:wooden_pickaxe",tag:{CustomModelData:6370002,Damage:0,display:{Name:'{"text":"Log Pickaxe","italic":false}'},wasd.custom_pick:23b,wasd_pickaxe:1b}},{Count:1b,Slot:19b,id:"minecraft:wooden_pickaxe",tag:{CustomModelData:6370003,Damage:0,display:{Name:'{"text":"Snow Pickaxe","italic":false}'},wasd.custom_pick:24b,wasd_pickaxe:1b}},{Count:1b,Slot:20b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370011,Damage:0,display:{Name:'{"text":"Ice Pickaxe","italic":false}'},wasd.custom_pick:28b,wasd_pickaxe:1b}},{Count:1b,Slot:21b,id:"minecraft:diamond_pickaxe",tag:{CustomModelData:6370012,Damage:0,display:{Name:'{"text":"Lucky Pickaxe","italic":false}'},wasd.custom_pick:29b,wasd_pickaxe:1b}},{Count:1b,Slot:22b,id:"minecraft:netherite_pickaxe",tag:{CustomModelData:6371006,Damage:0,display:{Name:'{"text":"Dragon Pickaxe","italic":false}'},wasd.custom_pick:30b,wasd_pickaxe:1b}}]}
}

function recipes{
    execute if score @s wasd.temp matches 5 if score miners w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:iron_block"},{Slot:3b,id:"minecraft:iron_ingot"},{Slot:4b,id:"minecraft:iron_shovel"},{Slot:5b,id:"minecraft:iron_ingot"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Miner\'s  Pickaxe","italic":false}'},CustomModelData:6370008,wasd.custom_pick:1b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score tunneler_dream w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:iron_block"},{Slot:1b,id:"minecraft:iron_block"},{Slot:2b,id:"minecraft:iron_block"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Tunnelers  Dream","italic":false}'},CustomModelData:6370009,wasd.custom_pick:2b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score molten w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:magma_block"},{Slot:1b,id:"minecraft:netherite_scrap"},{Slot:2b,id:"minecraft:magma_block"},{Slot:4b,id:"minecraft:blaze_rod"},{Slot:7b,id:"minecraft:blaze_rod"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Molten  Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:3b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score diamond_miner w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:diamond_block"},{Slot:3b,id:"minecraft:diamond"},{Slot:4b,id:"minecraft:netherite_shovel"},{Slot:5b,id:"minecraft:diamond"},{Slot:7b,id:"minecraft:netherite_ingot"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Diamond  Miner\'s Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:4b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score diamond_tunneler_dream w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:diamond_block"},{Slot:1b,id:"minecraft:diamond_block"},{Slot:2b,id:"minecraft:diamond_block"},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:7b,id:"minecraft:netherite_ingot"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Diamond  Tunnelers Dream","italic":false}'},CustomModelData:6370004,wasd.custom_pick:5b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score xp w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:diamond",tag:{wasd_diamond:1b}},{Slot:1b,id:"minecraft:diamond",tag:{wasd_diamond:1b}},{Slot:2b,id:"minecraft:diamond",tag:{wasd_diamond:1b}},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"XP  Pickaxe","italic":false}'},CustomModelData:6370005,wasd.custom_pick:6b}>
    execute if score @s wasd.temp matches 5 if score rainbow w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:diamond",tag:{wasd_diamond:3b}},{Slot:1b,id:"minecraft:diamond",tag:{wasd_diamond:3b}},{Slot:2b,id:"minecraft:diamond",tag:{wasd_diamond:3b}},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'[{"text":"R","color":"red","italic":false},{"text":"a","color":"gold"},{"text":"i","color":"yellow"},{"text":"n","color":"dark_green"},{"text":"b","color":"dark_aqua"},{"text":"o","color":"dark_blue"},{"text":"w","color":"dark_purple"},{"text":"  Pickaxe","italic":false}]'},CustomModelData:6370006,wasd.custom_pick:7b}>
    execute if score @s wasd.temp matches 5 if score momentum w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:emerald_block"},{Slot:1b,id:"minecraft:emerald_block"},{Slot:2b,id:"minecraft:emerald_block"},{Slot:4b,id:"minecraft:diamond_pickaxe"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Momentum  Pickaxe","italic":false}'},CustomModelData:6370007,wasd.custom_pick:8b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:efficiency",lvl:20s}]}>
    execute if score @s wasd.temp matches 5 if score firework w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:firework_rocket"},{Slot:1b,id:"minecraft:firework_rocket"},{Slot:2b,id:"minecraft:firework_rocket"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Firework  Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:9b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score pillow w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:white_bed"},{Slot:1b,id:"minecraft:white_bed"},{Slot:2b,id:"minecraft:white_bed"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Pillow  Pickaxe","italic":false}'},CustomModelData:6370004,wasd.custom_pick:10b,wasd_pickaxe:1b,RepairCost:9001,Enchantments:[{id:"minecraft:silk_touch",lvl:1s}]}>
    execute if score @s wasd.temp matches 5 if score tnt w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:tnt"},{Slot:1b,id:"minecraft:tnt"},{Slot:2b,id:"minecraft:tnt"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 golden_pickaxe <{display:{Name:'{"text":"TNT  Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:11b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score magnetic w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:redstone"},{Slot:3b,id:"minecraft:redstone"},{Slot:4b,id:"minecraft:iron_pickaxe"},{Slot:5b,id:"minecraft:lapis_lazuli"},{Slot:7b,id:"minecraft:lapis_lazuli"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Magnetic  Pickaxe","italic":false}'},CustomModelData:6370005,wasd.custom_pick:12b,wasd_pickaxe:1b}>

    execute if score @s wasd.temp matches 5 if score giant_diamond w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:diamond",tag:{wasd_diamond:5b}},{Slot:1b,id:"minecraft:diamond",tag:{wasd_diamond:5b}},{Slot:2b,id:"minecraft:diamond",tag:{wasd_diamond:5b}},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:7b,id:"minecraft:netherite_ingot"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Giant  Diamond Pickaxe","italic":false}'},CustomModelData:6370009,wasd.custom_pick:16b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score control w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:redstone_torch"},{Slot:3b,id:"minecraft:lever"},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:5b,id:"minecraft:lever"},{Slot:7b,id:"minecraft:redstone"}]} run recipe wasd.pick block.anvil.use smoke 100 netherite_pickaxe <{display:{Name:'{"text":"Control  Pickaxe","italic":false}'},CustomModelData:6371002,wasd.custom_pick:17b,wasd_pickaxe:1b}>

    execute if score @s wasd.temp matches 9 if score torch w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:torch"},{Slot:1b,id:"minecraft:coal_block"},{Slot:2b,id:"minecraft:torch"},{Slot:3b,id:"minecraft:coal_block"},{Slot:4b,id:"minecraft:iron_pickaxe"},{Slot:5b,id:"minecraft:coal_block"},{Slot:6b,id:"minecraft:torch"},{Slot:7b,id:"minecraft:coal_block"},{Slot:8b,id:"minecraft:torch"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Torch  Pickaxe","italic":false}'},CustomModelData:6370010,wasd.custom_pick:18b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score diamond_torch w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:diamond"},{Slot:3b,id:"minecraft:diamond"},{Slot:4b,id:"minecraft:iron_pickaxe",tag:{wasd.custom_pick:18b}},{Slot:5b,id:"minecraft:diamond"},{Slot:7b,id:"minecraft:diamond"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Diamond  Torch Pickaxe","italic":false}'},CustomModelData:6370010,wasd.custom_pick:19b,wasd_pickaxe:1b}>

    execute if score @s wasd.temp matches 5 if score efficient w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:enchanted_book",tag:{StoredEnchantments:[{id:"minecraft:efficiency",lvl:5s}]}},{Slot:1b,id:"minecraft:enchanted_book",tag:{StoredEnchantments:[{id:"minecraft:efficiency",lvl:5s}]}},{Slot:2b,id:"minecraft:enchanted_book",tag:{StoredEnchantments:[{id:"minecraft:efficiency",lvl:5s}]}},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:7b,id:"minecraft:netherite_ingot"}]} run recipe wasd.pick block.anvil.use smoke 100 netherite_pickaxe <{display:{Name:'{"text":"Efficient  Pickaxe","italic":false}'},CustomModelData:6371004,wasd.custom_pick:20b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:efficiency",lvl:8s}]}>
    execute if score @s wasd.temp matches 5 if score wither w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:wither_skeleton_skull"},{Slot:1b,id:"minecraft:wither_skeleton_skull"},{Slot:2b,id:"minecraft:wither_skeleton_skull"},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:7b,id:"minecraft:wither_skeleton_skull"}]} run recipe wasd.pick block.anvil.use smoke 100 netherite_pickaxe <{display:{Name:'{"text":"Wither  Pickaxe","italic":false}'},CustomModelData:6371005,wasd.custom_pick:21b,wasd_pickaxe:1b}>


    execute if score @s wasd.temp matches 5 if score log w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:oak_log"},{Slot:1b,id:"minecraft:oak_log"},{Slot:2b,id:"minecraft:oak_log"},{Slot:4b,id:"minecraft:oak_planks"},{Slot:7b,id:"minecraft:oak_planks"}]} run recipe wasd.pick block.anvil.use smoke 100 wooden_pickaxe <{display:{Name:'{"text":"Log  Pickaxe","italic":false}'},CustomModelData:6370002,wasd.custom_pick:23b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score snow w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:snowball"},{Slot:1b,id:"minecraft:snowball"},{Slot:2b,id:"minecraft:snowball"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 wooden_pickaxe <{display:{Name:'{"text":"Snow  Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:24b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 9 if score ice w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:ice"},{Slot:1b,id:"minecraft:packed_ice"},{Slot:2b,id:"minecraft:ice"},{Slot:3b,id:"minecraft:packed_ice"},{Slot:4b,id:"minecraft:diamond_pickaxe"},{Slot:5b,id:"minecraft:packed_ice"},{Slot:6b,id:"minecraft:ice"},{Slot:7b,id:"minecraft:packed_ice"},{Slot:8b,id:"minecraft:ice"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Ice  Pickaxe","italic":false}'},CustomModelData:6370011,wasd.custom_pick:28b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score lucky w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:diamond_ore"},{Slot:1b,id:"minecraft:gold_block"},{Slot:2b,id:"minecraft:emerald_ore"},{Slot:4b,id:"minecraft:nether_star"},{Slot:7b,id:"minecraft:netherite_ingot"}]} run recipe wasd.pick block.anvil.use smoke 100 diamond_pickaxe <{display:{Name:'{"text":"Lucky  Pickaxe","italic":false}'},CustomModelData:6370012,wasd.custom_pick:29b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 9 if score dragon w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:dragon_head"},{Slot:1b,id:"minecraft:dragon_head"},{Slot:2b,id:"minecraft:dragon_head"},{Slot:3b,id:"minecraft:dragon_breath"},{Slot:4b,id:"minecraft:netherite_pickaxe",tag:{wasd.custom_pick:21b}},{Slot:5b,id:"minecraft:dragon_breath"},{Slot:6b,id:"minecraft:dragon_breath"},{Slot:7b,id:"minecraft:elytra"},{Slot:8b,id:"minecraft:dragon_breath"}]} run recipe wasd.pick block.anvil.use smoke 100 netherite_pickaxe <{display:{Name:'{"text":"Dragon  Pickaxe","italic":false}'},CustomModelData:6371006,wasd.custom_pick:30b,wasd_pickaxe:1b}>

    function wasd.pick:patron/recipes

}


dir patron{

function give_items{
    give @p minecraft:golden_pickaxe{display:{Name:'{"text":"Cow Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:22b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Bookshelf Pickaxe","italic":false}'},CustomModelData:6370011,wasd.custom_pick:25b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Cake Pickaxe","italic":false}'},CustomModelData:6370012,wasd.custom_pick:26b,wasd_pickaxe:1b} 1
    give @p minecraft:iron_pickaxe{display:{Name:'{"text":"Creeper Pickaxe","italic":false}'},CustomModelData:6370013,wasd.custom_pick:27b,wasd_pickaxe:1b} 1
    give @p minecraft:netherite_pickaxe{display:{Name:'{"text":"Fortunate Pickaxe","italic":false}'},CustomModelData:6371007,wasd.custom_pick:31b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:fortune",lvl:5s}]} 1

}
function give_item_box{
    setblock ~ ~ ~ minecraft:light_blue_shulker_box[facing=up]{Items:[{Count:1b,Slot:0b,id:"minecraft:golden_pickaxe",tag:{CustomModelData:6370003,Damage:0,display:{Name:'{"text":"Cow Pickaxe","italic":false}'},wasd.custom_pick:22b,wasd_pickaxe:1b}},{Count:1b,Slot:1b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370011,Damage:0,display:{Name:'{"text":"Bookshelf Pickaxe","italic":false}'},wasd.custom_pick:25b,wasd_pickaxe:1b}},{Count:1b,Slot:2b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370012,Damage:0,display:{Name:'{"text":"Cake Pickaxe","italic":false}'},wasd.custom_pick:26b,wasd_pickaxe:1b}},{Count:1b,Slot:3b,id:"minecraft:iron_pickaxe",tag:{CustomModelData:6370013,Damage:0,display:{Name:'{"text":"Creeper Pickaxe","italic":false}'},wasd.custom_pick:27b,wasd_pickaxe:1b}},{Count:1b,Slot:4b,id:"minecraft:netherite_pickaxe",tag:{CustomModelData:6371007,Damage:0,Enchantments:[{id:"minecraft:fortune",lvl:5s}],display:{Name:'{"text":"Fortunate Pickaxe","italic":false}'},wasd.custom_pick:31b,wasd_pickaxe:1b}}]}
}



function recipes{
    execute if score @s wasd.temp matches 9 if score cow w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:cooked_beef"},{Slot:1b,id:"minecraft:cooked_beef"},{Slot:2b,id:"minecraft:cooked_beef"},{Slot:3b,id:"minecraft:beef"},{Slot:4b,id:"minecraft:iron_pickaxe"},{Slot:5b,id:"minecraft:beef"},{Slot:6b,id:"minecraft:leather"},{Slot:7b,id:"minecraft:leather"},{Slot:8b,id:"minecraft:leather"}]} run recipe wasd.pick block.anvil.use smoke 100 golden_pickaxe <{display:{Name:'{"text":"Cow  Pickaxe","italic":false}'},CustomModelData:6370003,wasd.custom_pick:22b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score bookshelf w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:bookshelf"},{Slot:1b,id:"minecraft:bookshelf"},{Slot:2b,id:"minecraft:bookshelf"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Bookshelf  Pickaxe","italic":false}'},CustomModelData:6370011,wasd.custom_pick:25b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score cake w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:cake"},{Slot:1b,id:"minecraft:cake"},{Slot:2b,id:"minecraft:cake"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Cake  Pickaxe","italic":false}'},CustomModelData:6370012,wasd.custom_pick:26b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 5 if score creeper w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:gunpowder"},{Slot:1b,id:"minecraft:creeper_head"},{Slot:2b,id:"minecraft:gunpowder"},{Slot:4b,id:"minecraft:stick"},{Slot:7b,id:"minecraft:stick"}]} run recipe wasd.pick block.anvil.use smoke 100 iron_pickaxe <{display:{Name:'{"text":"Creeper  Pickaxe","italic":false}'},CustomModelData:6370013,wasd.custom_pick:27b,wasd_pickaxe:1b}>
    execute if score @s wasd.temp matches 9 if score fortunate w.pick_setting matches 1 if block ~ ~-0.1 ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:gold_block"},{Slot:1b,id:"minecraft:diamond_block"},{Slot:2b,id:"minecraft:gold_block"},{Slot:3b,id:"minecraft:diamond_block"},{Slot:4b,id:"minecraft:netherite_pickaxe"},{Slot:5b,id:"minecraft:diamond_block"},{Slot:6b,id:"minecraft:gold_block"},{Slot:7b,id:"minecraft:diamond_block"},{Slot:8b,id:"minecraft:gold_block"}]} run recipe wasd.pick block.anvil.use smoke 100 netherite_pickaxe <{display:{Name:'{"text":"Fortunate  Pickaxe","italic":false}'},CustomModelData:6371007,wasd.custom_pick:31b,wasd_pickaxe:1b,Enchantments:[{id:"minecraft:fortune",lvl:5s}]}>

}


dir code{

function cake{
    effect give @p[scores={wasd.pick_type=26,wasd.iron_pick=1..}] saturation 1 0 true
    playsound entity.player.burp player @a ~ ~ ~ 0.1 1
    particle block cake ~ ~ ~ 0.1 0.1 0.1 0 10 force
}
function creeper{
    execute positioned ~ ~-1 ~ run tnt_explode 100
}
function cow{
    summon cow ~ ~ ~ {Invulnerable:1b,Glowing:1b,DeathLootTable:"none",Tags:["wasd.lib_entity_tick","wasd.ability","wasd.exploding_cow"]}
    particle flame ~ ~1 ~ 0.1 0.1 0.1 0.05 50 force
    playsound minecraft:entity.cow.hurt player @a ~ ~ ~ 0.5 1
}
function fortunate{
    execute align xyz positioned ~0.5 ~0.5 ~0.5 run block{
    particle dust_color_transition 1 0 0 1 1 0.6 0 ~ ~ ~ 0.2 0.2 0.2 0 5
    particle dust_color_transition 1 0.733 0 1 1 0.933 0 ~ ~ ~ 0.2 0.2 0.2 0 5
    }
}
function bookshelf{
    function wasd.lib:rng/1-100
    execute as @s[scores={wasd.rng=1}] run block{
        loot spawn ~ ~ ~ loot wasd.pick:enchanted_book
        particle dust 0.906 1.000 0.741 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
        particle dust 0.506 0.902 0.388 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
        particle dust 0.769 0.902 0.396 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
        particle dust 0.420 0.902 0.298 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
        particle dust 0.937 1.000 0.361 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
        playsound minecraft:entity.player.levelup player @a ~ ~ ~ 0.2 2
    }
}

}




}







dir code{

function diamond_strip{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        data modify entity @s Rotation set from entity @p[scores={wasd.pick_type=4,wasd.dia_pick=1..}] Rotation
        execute as @s[x_rotation=45..90] run tag @s add down
        execute as @s[x_rotation=-90..-45] run tag @s add up
        execute as @s[y_rotation=45..135] run tp @s ~ ~ ~ 90 ~
        execute as @s[y_rotation=136..225] run tp @s ~ ~ ~ 180 ~
        execute as @s[y_rotation=226..315] run tp @s ~ ~ ~ 270 ~
        execute as @s[y_rotation=316..44] run tp @s ~ ~ ~ 0 ~

        execute as @s[tag=!up,tag=!down] rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^1 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^1 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^2 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^2 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^3 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^3 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^4 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^4 {Tags:["wasd.mining_location"]}
        }
        execute at @e[tag=wasd.mining_location] if block ~ ~ ~ #wasd.tags:weak_stone run block{
            execute as @p[scores={wasd.pick_type=4,wasd.dia_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
    }
}
function diamond_tunnel{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        data modify entity @s Rotation set from entity @p[scores={wasd.pick_type=5,wasd.dia_pick=1..}] Rotation
            execute as @s[x_rotation=45..90] run tag @s add down
            execute as @s[x_rotation=-90..-45] run tag @s add up
            execute as @s[y_rotation=45..135] run tp @s ~ ~ ~ 90 ~
            execute as @s[y_rotation=136..225] run tp @s ~ ~ ~ 180 ~
            execute as @s[y_rotation=226..315] run tp @s ~ ~ ~ 270 ~
            execute as @s[y_rotation=316..44] run tp @s ~ ~ ~ 0 ~

        execute as @s[tag=!up,tag=!down] rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }
        execute as @s[tag=up] rotated 0 -90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }

        execute as @s[tag=down] rotated 0 90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }


        execute at @e[tag=wasd.mining_location] if block ~ ~ ~ #wasd.tags:weak_stone run block{
            execute as @p[scores={wasd.pick_type=5,wasd.dia_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
    }
}
function firework{
    function wasd.lib:affects/random_firework_explode

}
function momentum{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] as @p[scores={wasd.pick_type=8,wasd.dia_pick=1..}] run block{
        scoreboard players reset @s wasd.momentum
        effect clear @s minecraft:mining_fatigue
        tag @s add wasd.momentum_mined
    }
}
function momentum_math{
    effect give @s[tag=!wasd.momentum_mined] minecraft:mining_fatigue 1 2 true
    execute as @s[tag=wasd.momentum_mined] run scoreboard players add @s wasd.momentum 1
    tag @s[scores={wasd.momentum=20..}] remove wasd.momentum_mined
    scoreboard players reset @s[scores={wasd.momentum=20..}] wasd.momentum
}
function rainbow{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        execute positioned ~ ~-0.5 ~ run function wasd.lib:affects/drop_rainbow_dye
    }
}
function smelter{
    particle flame ~ ~ ~ 0 0 0 0.1 20
    particle smoke ~ ~ ~ 0 0 0 0.1 10
    playsound minecraft:entity.blaze.shoot block @a ~ ~ ~ 0.1 0.8
    data merge entity @s[nbt={Item:{id: "minecraft:stone"}}] {Item:{id:"minecraft:smooth_stone"}}
    data merge entity @s[nbt={Item:{id: "minecraft:cobblestone"}}] {Item:{id:"minecraft:stone"}}
    data merge entity @s[nbt={Item:{id: "minecraft:deepslate_iron_ore"}}] {Item:{id:"minecraft:iron_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:iron_ore"}}] {Item:{id:"minecraft:iron_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:raw_iron"}}] {Item:{id:"minecraft:iron_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:deepslate_gold_ore"}}] {Item:{id:"minecraft:gold_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:gold_ore"}}] {Item:{id:"minecraft:gold_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:raw_gold"}}] {Item:{id:"minecraft:gold_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:deepslate_copper_ore"}}] {Item:{id:"minecraft:copper_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:copper_ore"}}] {Item:{id:"minecraft:copper_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:raw_copper"}}] {Item:{id:"minecraft:copper_ingot"}}
    data merge entity @s[nbt={Item:{id: "minecraft:sand"}}] {Item:{id:"minecraft:glass"}}
    data merge entity @s[nbt={Item:{id: "minecraft:netherrack"}}] {Item:{id:"minecraft:nether_brick"}}
    data merge entity @s[nbt={Item:{id: "minecraft:ancient_debris"}}] {Item:{id:"minecraft:netherite_scrap"}}

}
function strip{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        data modify entity @s Rotation set from entity @p[scores={wasd.pick_type=1,wasd.iron_pick=1..}] Rotation
        execute as @s[x_rotation=45..90] run tag @s add down
        execute as @s[x_rotation=-90..-45] run tag @s add up
        execute as @s[y_rotation=45..135] run tp @s ~ ~ ~ 90 ~
        execute as @s[y_rotation=136..225] run tp @s ~ ~ ~ 180 ~
        execute as @s[y_rotation=226..315] run tp @s ~ ~ ~ 270 ~
        execute as @s[y_rotation=316..44] run tp @s ~ ~ ~ 0 ~

        execute as @s[tag=!up,tag=!down] rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^1 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^1 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^2 {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^2 {Tags:["wasd.mining_location"]}
        }
        execute at @e[tag=wasd.mining_location] if block ~ ~ ~ #wasd.tags:weak_stone run block{
            execute as @p[scores={wasd.pick_type=1,wasd.iron_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
    }
}
function tnt{
    function wasd.lib:affects/tnt_explode
}
function tunnel{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        data modify entity @s Rotation set from entity @p[scores={wasd.pick_type=2,wasd.iron_pick=1..}] Rotation
        execute as @s[x_rotation=45..90] run tag @s add down
        execute as @s[x_rotation=-90..-45] run tag @s add up
        execute as @s[y_rotation=45..135] run tp @s ~ ~ ~ 90 ~
        execute as @s[y_rotation=136..225] run tp @s ~ ~ ~ 180 ~
        execute as @s[y_rotation=226..315] run tp @s ~ ~ ~ 270 ~
        execute as @s[y_rotation=316..44] run tp @s ~ ~ ~ 0 ~

        execute as @s[tag=!up,tag=!down] rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }
        execute as @s[tag=up] rotated 0 -90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }

        execute as @s[tag=down] rotated 0 90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }

        execute at @e[tag=wasd.mining_location] if block ~ ~ ~ #wasd.tags:weak_stone run block{
            execute as @p[scores={wasd.pick_type=2,wasd.iron_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
    }
}
function xp{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        function wasd.lib:rng/1-3
        execute as @s[scores={wasd.rng=1}] run block{
            summon experience_orb ~ ~ ~ {Value:1}
            particle dust 0.906 1.000 0.741 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
            particle dust 0.506 0.902 0.388 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
            particle dust 0.769 0.902 0.396 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
            particle dust 0.420 0.902 0.298 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
            particle dust 0.937 1.000 0.361 3 ~ ~ ~ 0.2 0.2 0.2 1 1 normal
            playsound minecraft:entity.player.levelup player @a ~ ~ ~ 0.2 2
        }
    }
}
function magnetic{
    tp @s @p[scores={wasd.iron_pick=1..}]
    data merge entity @s {PickupDelay:0}
    particle dust 1.000 0.000 0.000 2 ~ ~ ~ 0.1 0.1 0.1 1 3 normal
    particle dust 0.129 0.247 1.000 2 ~ ~ ~ 0.1 0.1 0.1 1 3 normal
}
function obsidian{

}
function giant_diamond{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        tp @s ~ ~ ~ 0 0
        execute rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            execute positioned ^ ^ ^1 run function wasd.lib:detection/vertical/3x3
            execute positioned ^ ^ ^ run function wasd.lib:detection/vertical/3x3
            execute positioned ^ ^ ^-1 run function wasd.lib:detection/vertical/3x3
        }
        execute at @e[tag=wasd.location] if block ~ ~ ~ #minecraft:mineable/pickaxe run block{
            execute as @p[scores={wasd.pick_type=16,wasd.dia_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
        kill @e[tag=wasd.location]
    }
}
    function control{
        execute if score @s w.pick_sneaking matches 1.. run block{
            effect give @s mining_fatigue 1 0 true
            execute if entity @s[nbt={SelectedItem:{tag:{CustomModelData:6371002}}}] run block{
                function wasd.lib:items/inventory/mainhand/inventory_to_box
                execute at @e[tag=wasd.box_location] run data modify block ~ ~ ~ Items[0].tag.CustomModelData set value 6371003
                execute at @e[tag=wasd.box_location] run function wasd.lib:items/inventory/mainhand/box_to_inventory
            }

        }

        execute unless score @s w.pick_sneaking matches 1.. run block{
            execute if entity @s[nbt={SelectedItem:{tag:{CustomModelData:6371003}}}] run block{
                effect clear @s mining_fatigue
                function wasd.lib:items/inventory/mainhand/inventory_to_box
                execute at @e[tag=wasd.box_location] run data modify block ~ ~ ~ Items[0].tag.CustomModelData set value 6371002
                execute at @e[tag=wasd.box_location] run function wasd.lib:items/inventory/mainhand/box_to_inventory

            }
        }

    }
function torch{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        execute if predicate light_level:0 if block ~ ~ ~ #wasd.tags:air unless block ~ ~-1 ~ #wasd.tags:nonsolid run block{
            setblock ~ ~ ~ torch
            execute align xyz positioned ~0.5 ~0.5 ~0.5 run particle flame ~ ~ ~ 0 0 0 0.05 10 force
            playsound item.firecharge.use player @a ~ ~ ~ 1 0.5
        }
    }
}

function wither{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        function wasd.lib:detection/cube/5x5
        execute as @e[tag=wasd.location,type=marker] at @s run block{
            execute if block ~ ~ ~ #wasd.tags:weak_stone run summon marker ~ ~ ~ {Tags:["wasd.withered_block","wasd.lib_entity_tick"]}
            execute if block ~ ~ ~ #wasd.tags:ores run block{
                function wasd.lib:rng/1-10
                execute as @s[scores={wasd.rng=1}] run summon marker ~ ~ ~ {Tags:["wasd.withered_block","wasd.lib_entity_tick"]}

                }
            }
        kill @e[tag=wasd.location,type=marker]
        function wasd.pick:code/kill_weak_stone
    }
}

function dragon{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        function wasd.lib:detection/cube/5x5
        execute as @e[tag=wasd.location,type=marker] at @s run block{
            execute if block ~ ~ ~ #wasd.tags:weak_stone run summon marker ~ ~ ~ {Tags:["wasd.dragoned_block","wasd.lib_entity_tick"]}
            }
        kill @e[tag=wasd.location,type=marker]
        function wasd.pick:code/kill_weak_stone
    }
}



function kill_weak_stone{
    summon armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Tags:["wasd.predicate_check"],ArmorItems:[{},{},{id:"minecraft:debug_stick",Count:1b},{}]}
    tag @s add wasd.checking_validity
    data modify entity @e[type=armor_stand,tag=wasd.predicate_check,sort=nearest,limit=1] ArmorItems[2] set from entity @s Item
    execute as @e[type=armor_stand,tag=wasd.predicate_check,sort=nearest,limit=1] run block{
    execute if predicate wasd.pick:weak_stone run kill @e[type=item,tag=wasd.checking_validity,sort=nearest,limit=1]
    kill @s
    }
    
}

function log{
    function wasd.pick:invalid_mine
    execute unless entity @s[tag=wasd.invalid_mine_attempt] run block{
        data modify entity @s Rotation set from entity @p[scores={wasd.pick_type=23,wasd.wood_pick=1..}] Rotation
        execute as @s[x_rotation=45..90] run tag @s add down
        execute as @s[x_rotation=-90..-45] run tag @s add up
        execute as @s[y_rotation=45..135] run tp @s ~ ~ ~ 90 ~
        execute as @s[y_rotation=136..225] run tp @s ~ ~ ~ 180 ~
        execute as @s[y_rotation=226..315] run tp @s ~ ~ ~ 270 ~
        execute as @s[y_rotation=316..44] run tp @s ~ ~ ~ 0 ~

        execute as @s[tag=!up,tag=!down] rotated as @s align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }
        execute as @s[tag=up] rotated 0 -90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }

        execute as @s[tag=down] rotated 0 90 align xyz positioned ~0.5 ~0.5 ~0.5 run block{
            summon minecraft:area_effect_cloud ^1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^1 ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^ ^-1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^1 ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^ ^ {Tags:["wasd.mining_location"]}
            summon minecraft:area_effect_cloud ^-1 ^-1 ^ {Tags:["wasd.mining_location"]}
        }

        execute at @e[tag=wasd.mining_location] if block ~ ~ ~ #wasd.tags:weak_stone run block{
            execute as @p[scores={wasd.pick_type=23,wasd.wood_pick=1..}] run loot spawn ~ ~ ~ mine ~ ~ ~ mainhand
            setblock ~ ~ ~ air replace
        }
    }
}
function snow{
    particle snowflake ~0.5 ~0.5 ~0.5 0.2 0.2 0.2 0.05 10 force
    playsound minecraft:block.snow.break player @a ~ ~ ~ 0.2 1
}
function ice{
    execute align xyz run particle snowflake ~0.5 ~0.5 ~0.5 0.2 0.2 0.2 0.05 15 force
    playsound minecraft:block.snow.break player @a ~ ~ ~ 0.5 1
    execute positioned ~1 ~ ~ run function wasd.pick:code/ice_pick_freeze
    execute positioned ~-1 ~ ~ run function wasd.pick:code/ice_pick_freeze
    execute positioned ~ ~1 ~ run function wasd.pick:code/ice_pick_freeze
    execute positioned ~ ~-1 ~ run function wasd.pick:code/ice_pick_freeze
    execute positioned ~ ~ ~1 run function wasd.pick:code/ice_pick_freeze
    execute positioned ~ ~ ~-1 run function wasd.pick:code/ice_pick_freeze
}
function ice_pick_freeze{
    execute if block ~ ~ ~ #wasd.tags:liquids[level=0] run particle snowflake ~0.5 ~0.5 ~0.5 0.3 0.3 0.3 0.01 30 force
    execute if block ~ ~ ~ lava[level=0] run setblock ~ ~ ~ obsidian
    execute if block ~ ~ ~ water[level=0] run setblock ~ ~ ~ ice


}
function lucky{
    function wasd.lib:rng/1-2
    execute as @s[scores={wasd.rng=1}] align xyz positioned ~0.5 ~0.5 ~0.5 run block{
    scoreboard players reset @s wasd.rng
    #worst
    execute as @s[nbt={Item:{id:"minecraft:coal"}}] run block{
        function wasd.lib:rng/1-60
        scoreboard players add @s wasd.rng 2
    }
    execute as @s[nbt={Item:{id:"minecraft:quartz"}}] run block{
        function wasd.lib:rng/1-60
        scoreboard players add @s wasd.rng 2
    }
    execute as @s[nbt={Item:{id:"minecraft:gold_nugget"}}] run block{
        function wasd.lib:rng/1-60
        scoreboard players add @s wasd.rng 2
    }
    execute as @s[nbt={Item:{id:"minecraft:raw_copper"}}] run block{
        function wasd.lib:rng/1-50
        scoreboard players add @s wasd.rng 2
    }
    execute as @s[nbt={Item:{id:"minecraft:raw_iron"}}] run block{
        function wasd.lib:rng/1-45
        scoreboard players add @s wasd.rng 2
    }

    #better
    execute as @s[nbt={Item:{id:"minecraft:lapis_lazuli"}}] run function wasd.lib:rng/1-9
    execute as @s[nbt={Item:{id:"minecraft:raw_gold"}}] run function wasd.lib:rng/1-7


    execute as @s[nbt={Item:{id:"minecraft:diamond"}}] run function wasd.lib:rng/1-4
    #best
    execute as @s[nbt={Item:{id:"minecraft:emerald"}}] run function wasd.lib:rng/1-2


    #best
    execute as @s[scores={wasd.rng=1}] run block{
        particle dust 0 0.8 1 3 ~ ~ ~ 0.2 0.2 0.2 0 10 force
        playsound block.note_block.bit player @a ~ ~ ~ 1 2
        loot spawn ~ ~ ~ loot wasd.pick:lucky/best
    }
    #good
    execute as @s[scores={wasd.rng=2}] run block{
        particle dust 0.235 1 0 3 ~ ~ ~ 0.2 0.2 0.2 0 10 force
        playsound block.note_block.bit player @a ~ ~ ~ 1 1
        loot spawn ~ ~ ~ loot wasd.pick:lucky/good
    }
    #okay
    execute as @s[scores={wasd.rng=3..8}] run block{
        particle dust 1 0.933 0 3 ~ ~ ~ 0.2 0.2 0.2 0 10 force
        playsound block.note_block.bit player @a ~ ~ ~ 1 0.5
        loot spawn ~ ~ ~ loot wasd.pick:lucky/okay
    }

    #bad
    execute as @s[scores={wasd.rng=9..}] run block{
        particle dust 0.439 0 0 3 ~ ~ ~ 0.2 0.2 0.2 0 10 force
        playsound minecraft:block.note_block.bass player @a ~ ~ ~ 1 1
        loot spawn ~ ~ ~ loot wasd.pick:lucky/bad
    }

    }
}


}

function invalid_mine{
    summon armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Tags:["wasd.predicate_check"],ArmorItems:[{},{},{id:"minecraft:debug_stick",Count:1b},{}]}
    tag @s add wasd.checking_validity
    data modify entity @e[type=armor_stand,tag=wasd.predicate_check,sort=nearest,limit=1] ArmorItems[2] set from entity @s Item
    execute as @e[type=armor_stand,tag=wasd.predicate_check,sort=nearest,limit=1] run block{
    execute if predicate wasd.pick:invalid_mine run tag @e[type=item,tag=wasd.checking_validity,sort=nearest,limit=1] add wasd.invalid_mine_attempt
    kill @s
    }

#possibly add coral and coral fans

}

